\version "2.24.1"

#(for-each
   (lambda (suffix)
     (let ((file (format #f "~3,'0d~a.bars" N suffix)))
       (if (access? file F_OK) (delete-file file))))
   '("" "a" "b" "c"))

Bar_Count_engraver =
#(lambda (context)
   (define bars #f)
   (define firstbar 0)
   (define lastbar +inf.0)
   (define nullbars '())

   (make-engraver

     ((initialize translator)
       (if (not final)
         (let* ((outfile (ly:output-def-lookup $defaultpaper 'output-filename #f))
                (prefix  (substring outfile 0 (string-index outfile #\-)))
                (barfile (string-join `(,prefix "bars") ".")))
           (set! bars (open-file barfile "a"))
           (set! firstbar +inf.0)
           (set! lastbar 0)
           (set! nullbars '()))))

     ((finalize translator)
       (if (not final)
         (begin
           (format bars "Bar count ~a\n" (- lastbar firstbar (length nullbars) -1))
           (close-port bars))))

     (acknowledgers
       ((bar-line-interface engraver grob source-engraver)
         (let* ((thisbar (ly:context-property context 'currentBarNumber 0))
                (barline (ly:context-property context 'currentBarLine #f))
                (bartype (if barline (ly:grob-property barline 'glyph) "|")))
           (if (and (string=? bartype "") (not (memq thisbar nullbars)))
             (set! nullbars (append nullbars (list thisbar))))
           (set! lastbar thisbar)
           (set! firstbar (inexact->exact (min firstbar thisbar))))))
   ))
